;==============================================================================
pro Circle::CalculatePerimeter

self->GetProperty, radius=radius
self.perimeter = 2 * !pi * radius

end


;==============================================================================
pro Circle::CalculateArea

self->GetProperty, radius=radius
Self.area = !pi * radius^2

end


;==============================================================================
pro Circle::SetProperty, radius=radius, _EXTRA=etc

if (n_elements(radius) gt 0 && radius gt 0.0) then begin
    self.radius = radius
    self->CalculateArea
    self->CalculatePerimeter
endif

; Call superclass method for anything else
if (n_elements(etc) gt 0) then self->Shape::SetProperty, _EXTRA=etc


end


;==============================================================================
pro Circle::GetProperty, radius=radius, _REF_EXTRA=etc

if (arg_present(radius)) then $
    radius = self.radius

; Call superclass method for anything else
if (n_elements(etc) gt 0) then self->Shape::GetProperty, _EXTRA=etc

end


;==============================================================================
; The Constructor
; Called during the initialization of objects of this class
function Circle::Init, _REF_EXTRA=etc

; Call superclass constructor and exit in case of errors.
result = self->Shape::Init(_EXTRA=etc)
if (result ne 1) then return, 0

; initialize data members
self.radius = 0.0

; if any keywords are present, pass on to SetProperty method
if (n_elements(etc) gt 0) then self->SetProperty, _EXTRA=etc

return, 1

end


;==============================================================================
pro Circle__define

struct = {Circle $
          ,inherits Shape $ ; inherit all variables defined in Shape class structure
          ,radius:0.0 $
         }

end