;==============================================================================
pro Rectangle::CalculatePerimeter

self->GetProperty, width=width, length=length
self.perimeter = 2*(width + length)

end


;==============================================================================
pro Rectangle::CalculateArea

self->GetProperty, width=width, length=length
Self.area = width*length

end


;==============================================================================
pro Rectangle::SetProperty, width=width, length=length, _EXTRA=etc

if (n_elements(width) gt 0 && width gt 0.0) then begin
    self.width = width
    self->CalculateArea
    self->CalculatePerimeter
endif

if (n_elements(length) gt 0 && length gt 0.0) then begin
    self.length = length
    self->CalculateArea
    self->CalculatePerimeter
endif

; Call superclass method for anything else
if (n_elements(etc) gt 0) then self->Shape::SetProperty, _EXTRA=etc


end


;==============================================================================
pro Rectangle::GetProperty, width=width, length=length, _REF_EXTRA=etc

if (arg_present(width)) then $
    width = self.width

if (arg_present(length)) then $
    length = self.length

; Call superclass method for anything else
if (n_elements(etc) gt 0) then self->Shape::GetProperty, _EXTRA=etc

end


;==============================================================================
; The Constructor
; Called during the initialization of objects of this class
function Rectangle::Init, _REF_EXTRA=etc

; Call superclass constructor and exit in case of errors (ie return value is not 1).
result = self->Shape::Init(_EXTRA=etc)
if (result ne 1) then return, 0

; initialize data members
self.width = 0.0
self.length = 0.0

; if any keywords are present, pass on to SetProperty method
if (n_elements(etc) gt 0) then self->SetProperty, _EXTRA=etc

return, 1

end


;==============================================================================
pro Rectangle__define

struct = {Rectangle $
          ,inherits Shape $ ; inherit all variables defined in Shape class structure
          ,width:0.0 $
          ,length:0.0 $
         }

end
