;==============================================================================
pro Square::SetProperty, width=width, length=length, _EXTRA=etc

if (n_elements(width) gt 0 && width gt 0.0) then begin
    self.width = width
    self.length = width
    self->CalculateArea
    self->CalculatePerimeter
endif

if (n_elements(length) gt 0 && length gt 0.0) then begin
    self.length = length
    self.width = length
    self->CalculateArea
    self->CalculatePerimeter
endif

; Call superclass method for anything else
if (n_elements(etc) gt 0) then self->Rectangle::SetProperty, _EXTRA=etc

end


;==============================================================================
; The Constructor
; Called during the initialization of objects of this class
function Square::Init, _REF_EXTRA=etc

; Call superclass constructor and exit in case of errors.
result = self->Rectangle::Init(_EXTRA=etc)
if (result ne 1) then return, 0


; if any keywords are present, pass on to SetProperty method
if (n_elements(etc) gt 0) then self->SetProperty, _EXTRA=etc

return, 1

end


;==============================================================================
pro Square__define

struct = {Square $
          ,inherits Rectangle $ ; inherit Rectangle class
         }

end